<?php
/**
 * @file
 * File with field form specific functions.
 */

/**
 * Add node fields to node edit form.
 *
 * Changed node fields will be saved on hook_node_submit.
 */
function sky_field_form_edit($entity_type, $entity, &$form, &$form_state) {
  $sky_fields = sky_field_get_sky_fields($entity_type, $entity);
  if (empty($sky_fields)) {
    return;
  }
  $form_state['sky_fields'] = $sky_fields;
  $form['sky_fields'] = sky_field_value_fields_form($entity, $sky_fields);
}

/**
 * Building value of fields form.
 */
function sky_field_value_fields_form($entity, $sky_fields) {
  $form = array(
    '#type' => 'fieldset',
    '#title' => t('Sky fields'),
    '#tree' => TRUE,
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  foreach ($sky_fields as $field) {
    $widget = sky_field_sky_field_widget_form($field);
    drupal_alter('sky_field_value_form', $entity, $field, $widget);
    $form[$field['id']] = $widget;
  }
  return $form;
}
